@use 'breakpoint';
@use 'styles-variables' as *;

@mixin heading($type) {
	--digi--heading-#{$type}--font-size: var(--digi--typography--heading-#{$type}--font-size--mobile);
	--digi--heading-#{$type}--line-height: var(--digi--typography--heading-#{$type}--line-height--mobile);

	font-family: var(--digi--global--typography--font-family--default);
	font-size: var(--digi--heading-#{$type}--font-size);
	line-height: var(--digi--heading-#{$type}--line-height);
	font-weight: var(--digi--typography--heading-#{$type}--font-weight--mobile);
	margin-block-end: 0;

	@media (min-width: $digi--breakpoint--medium) {
		@content;
	}

	@include breakpoint.medium {
		--digi--heading-#{$type}--font-size: var(--digi--typography--heading-#{$type}--font-size--desktop);
		--digi--heading-#{$type}--line-height: var(--digi--typography--heading-#{$type}--line-height--desktop);
	}

	@include breakpoint.large {
		--digi--heading-#{$type}--font-size: var(--digi--typography--heading-#{$type}--font-size--desktop-large);
		--digi--heading-#{$type}--line-height: var(--digi--typography--heading-#{$type}--line-height--desktop-large);
	}
}

@mixin heading-3 {
	@include heading(3);
}

@mixin heading-4 {
	@include heading(4);
}

@mixin heading-section {
	@include heading(3);

	font-weight: var(--digi--global--typography--font-weight--regular);

	&::after {
		content: '';
		margin-block-start: var(--digi--margin--text-small);
		display: block;
		width: var(--digi--container-gutter--medium);
		height: var(--digi--border-width--secondary);
		background: var(--digi--color--border--neutral-2);
	}
}

@mixin preamble {
	font-family: var(--digi--global--typography--font-family--default);
	font-size: var(--digi--typography--preamble--font-size--mobile);
	font-weight: var(--digi--typography--preamble--font-weight--desktop);
	color: var(--digi--color--text--primary);
	max-width: var(--digi--paragraph-width--medium);

	@include breakpoint.large {
		font-size: var(--digi--typography--preamble--font-size--desktop);
	}
}

@mixin preheader {
	font-family: var(--digi--global--typography--font-family--default);
	font-size: var(--digi--typography--font-size--desktop);
	font-weight: var(--digi--global--typography--font-weight--semibold);
	line-height: 1.5;
	text-transform: uppercase;
	letter-spacing: 0.02em;
	color: var(--digi--color--text--primary);
}
